/*
 * Copyright 2023 Free Software Foundation, Inc.
 *
 * This file is part of GNU Radio
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 */

/***********************************************************************************/
/* This file is automatically generated using bindtool and can be manually edited  */
/* The following lines can be configured to regenerate this file during cmake      */
/* If manual edits are made, the following tags should be modified accordingly.    */
/* BINDTOOL_GEN_AUTOMATIC(0)                                                       */
/* BINDTOOL_USE_PYGCCXML(0)                                                        */
/* BINDTOOL_HEADER_FILE(ax100_decoder.h)                                           */
/* BINDTOOL_HEADER_FILE_HASH(0)                                                    */
/***********************************************************************************/

#include <pybind11/complex.h>
#include <pybind11/pybind11.h>
#include <pybind11/stl.h>

namespace py = pybind11;
#include <gnuradio/satnogs/ax100_mode5.h>
// pydoc.h is automatically generated in the build directory
#include <gnuradio/satnogs/ax100_decoder.h>
#include <ax100_mode5_pydoc.h>
// pydoc.h is automatically generated in the build directory
#include <gnuradio/satnogs/ax100_mode6.h>
#include <ax100_decoder_pydoc.h>
// pydoc.h is automatically generated in the build directory
#include <ax100_mode6_pydoc.h>

void bind_ax100_decoder(py::module& m)
{

    using ax100_decoder = ::gr::satnogs::ax100_decoder;
    using ax100_mode5 = ::gr::satnogs::ax100_mode5;
    using ax100_mode6 = ::gr::satnogs::ax100_mode6;

    py::class_<ax100_decoder, std::shared_ptr<ax100_decoder>>(
        m, "ax100_decoder", D(ax100_decoder))
        .def(py::init<>(), D(ax100_decoder, ax100_decoder, 0))
        .def(py::init<gr::satnogs::ax100_decoder const&>())
        .def_static("mode5",
                    &ax100_decoder::mode5,
                    py::arg("preamble"),
                    py::arg("preamble_threshold"),
                    py::arg("sync"),
                    py::arg("sync_threshold"),
                    py::arg("crc"),
                    py::arg("descrambler"),
                    py::arg("enable_rs"),
                    D(ax100_decoder, mode5_make))
        .def_static("mode6",
                    &ax100_decoder::mode6,
                    py::arg("crc"),
                    py::arg("descrambler"),
                    py::arg("ax25_descramble"),
                    D(ax100_mode6, make));

    py::class_<ax100_mode5, gr::satnogs::decoder, std::shared_ptr<ax100_mode5>>(
        m, "ax100_mode5", D(ax100_mode5))
        .def(py::init(&ax100_mode5::make),
             py::arg("preamble"),
             py::arg("preamble_threshold"),
             py::arg("sync"),
             py::arg("sync_threshold"),
             py::arg("crc"),
             py::arg("descrambler"),
             py::arg("enable_rs"),
             D(ax100_mode5, make))
        .def("decode",
             &ax100_mode5::decode,
             py::arg("in"),
             py::arg("len"),
             D(ax100_mode5, decode))
        .def("reset", &ax100_mode5::reset, D(ax100_mode5, reset))
        .def("input_multiple",
             &ax100_mode5::input_multiple,
             D(ax100_mode5, input_multiple));

    py::class_<ax100_mode6, gr::satnogs::decoder, std::shared_ptr<ax100_mode6>>(
        m, "ax100_mode6", D(ax100_mode6))
        .def(py::init(&ax100_mode6::make),
             py::arg("crc"),
             py::arg("descrambler"),
             py::arg("ax25_descramble"),
             D(ax100_mode6, make))
        .def("decode",
             &ax100_mode6::decode,
             py::arg("in"),
             py::arg("len"),
             D(ax100_mode6, decode))
        .def("reset", &ax100_mode6::reset, D(ax100_mode6, reset));
}
