/*
 * Copyright 2023 Free Software Foundation, Inc.
 *
 * This file is part of GNU Radio
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 */

/***********************************************************************************/
/* This file is automatically generated using bindtool and can be manually edited  */
/* The following lines can be configured to regenerate this file during cmake      */
/* If manual edits are made, the following tags should be modified accordingly.    */
/* BINDTOOL_GEN_AUTOMATIC(0)                                                       */
/* BINDTOOL_USE_PYGCCXML(0)                                                        */
/* BINDTOOL_HEADER_FILE(ax100_encoder.h)                                           */
/* BINDTOOL_HEADER_FILE_HASH(0)                                                    */
/***********************************************************************************/

#include <pybind11/complex.h>
#include <pybind11/pybind11.h>
#include <pybind11/stl.h>

namespace py = pybind11;

#include <gnuradio/satnogs/ax100_encoder.h>
#include <gnuradio/satnogs/ax100_mode5_encoder.h>
#include <gnuradio/satnogs/ax100_mode6_encoder.h>
// pydoc.h is automatically generated in the build directory
#include <ax100_encoder_pydoc.h>

void bind_ax100_encoder(py::module& m)
{
    using ax100_encoder = ::gr::satnogs::ax100_encoder;
    using ax100_mode5_encoder = ::gr::satnogs::ax100_mode5_encoder;
    using ax100_mode6_encoder = ::gr::satnogs::ax100_mode6_encoder;

    py::class_<ax100_encoder, std::shared_ptr<ax100_encoder>>(
        m, "ax100_encoder", D(ax100_encoder))
        .def(py::init<>(), D(ax100_encoder, ax100_encoder, 0))
        .def(py::init<gr::satnogs::ax100_encoder const&>())
        .def_static("mode5",
                    &ax100_encoder::mode5,
                    py::arg("preamble"),
                    py::arg("sync"),
                    py::arg("crc"),
                    py::arg("scrambler"),
                    py::arg("enable_rs"),
                    D(ax100_mode5_encoder, make))
        .def_static("mode6",
                    &ax100_encoder::mode6,
                    py::arg("preamble_len"),
                    py::arg("postamble_len"),
                    py::arg("scrambler"),
                    py::arg("scramble"),
                    py::arg("nrzi"),
                    py::arg("crc"),
                    D(ax100_mode6_encoder, make));

    py::class_<ax100_mode5_encoder,
               gr::satnogs::encoder,
               std::shared_ptr<ax100_mode5_encoder>>(
        m, "ax100_mode5_encoder", D(ax100_mode5_encoder))
        .def(py::init(&ax100_mode5_encoder::make),
             py::arg("preamble"),
             py::arg("sync"),
             py::arg("crc"),
             py::arg("scrambler"),
             py::arg("enable_rs"),
             D(ax100_mode5_encoder, make))
        .def("encode",
             &ax100_mode5_encoder::encode,
             py::arg("msg"),
             D(ax100_mode5_encoder, encode));

    py::class_<ax100_mode6_encoder,
               gr::satnogs::encoder,
               std::shared_ptr<ax100_mode6_encoder>>(
        m, "ax100_mode6_encoder", D(ax100_mode6_encoder))
        .def(py::init(&ax100_mode6_encoder::make),
             py::arg("preamble_len"),
             py::arg("postamble_len"),
             py::arg("scrambler"),
             py::arg("scramble"),
             py::arg("nrzi"),
             py::arg("crc"),
             D(ax100_mode6_encoder, make))
        .def("encode",
             &ax100_mode6_encoder::encode,
             py::arg("msg"),
             D(ax100_mode6_encoder, encode));
}
