/*
 * Copyright 2023 Free Software Foundation, Inc.
 *
 * This file is part of GNU Radio
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 */

/***********************************************************************************/
/* This file is automatically generated using bindtool and can be manually edited  */
/* The following lines can be configured to regenerate this file during cmake      */
/* If manual edits are made, the following tags should be modified accordingly.    */
/* BINDTOOL_GEN_AUTOMATIC(0)                                                       */
/* BINDTOOL_USE_PYGCCXML(0)                                                        */
/* BINDTOOL_HEADER_FILE(ax25_decoder.h)                                        */
/* BINDTOOL_HEADER_FILE_HASH(857c29b0b2b5dad3d7c78ce9a5316153)                     */
/***********************************************************************************/

#include <pybind11/complex.h>
#include <pybind11/pybind11.h>
#include <pybind11/stl.h>

namespace py = pybind11;

#include <gnuradio/satnogs/ax25_decoder.h>
#include <gnuradio/satnogs/decoder.h>
// pydoc.h is automatically generated in the build directory
#include <ax25_decoder_pydoc.h>

void bind_ax25_decoder(py::module& m)
{

    using ax25_decoder = ::gr::satnogs::ax25_decoder;
    py::class_<ax25_decoder, gr::satnogs::decoder, std::shared_ptr<ax25_decoder>>(
        m, "ax25_decoder", D(ax25_decoder))

        .def(py::init(&ax25_decoder::make),
             py::arg("addr"),
             py::arg("ssid"),
             py::arg("promisc") = false,
             py::arg("descramble") = true,
             py::arg("crc_check") = true,
             py::arg("max_frame_len") = 512,
             py::arg("error_correction") = false,
             D(ax25_decoder, make))


        .def("decode",
             &ax25_decoder::decode,
             py::arg("in"),
             py::arg("len"),
             D(ax25_decoder, decode))


        .def("reset", &ax25_decoder::reset, D(ax25_decoder, reset))

        ;
}
