/*
 * Copyright 2023 Free Software Foundation, Inc.
 *
 * This file is part of GNU Radio
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 */

/***********************************************************************************/
/* This file is automatically generated using bindtool and can be manually edited  */
/* The following lines can be configured to regenerate this file during cmake      */
/* If manual edits are made, the following tags should be modified accordingly.    */
/* BINDTOOL_GEN_AUTOMATIC(0)                                                       */
/* BINDTOOL_USE_PYGCCXML(0)                                                        */
/* BINDTOOL_HEADER_FILE(ax25_encoder.h)                                        */
/* BINDTOOL_HEADER_FILE_HASH(a303e3b3a48caa90a9d2a60e919222de)                     */
/***********************************************************************************/

#include <pybind11/complex.h>
#include <pybind11/pybind11.h>
#include <pybind11/stl.h>

namespace py = pybind11;
#include <gnuradio/satnogs/ax25_encoder.h>
#include <gnuradio/satnogs/encoder.h>
// pydoc.h is automatically generated in the build directory
#include <ax25_encoder_pydoc.h>

void bind_ax25_encoder(py::module& m)
{
    using ax25_encoder = ::gr::satnogs::ax25_encoder;
    py::class_<ax25_encoder, gr::satnogs::encoder, std::shared_ptr<ax25_encoder>>(
        m, "ax25_encoder", D(ax25_encoder))

        .def(py::init(&ax25_encoder::make),
             py::arg("dest_addr"),
             py::arg("dest_ssid"),
             py::arg("src_addr"),
             py::arg("src_ssid"),
             py::arg("preamble_len") = 16,
             py::arg("postamble_len") = 16,
             py::arg("scramble") = true,
             py::arg("nrzi") = true,
             D(ax25_encoder, make))


        .def("encode", &ax25_encoder::encode, py::arg("msg"), D(ax25_encoder, encode))

        ;
}
