/*
 * Copyright 2024 Free Software Foundation, Inc.
 *
 * This file is part of GNU Radio
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 */

/***********************************************************************************/
/* This file is automatically generated using bindtool and can be manually edited  */
/* The following lines can be configured to regenerate this file during cmake      */
/* If manual edits are made, the following tags should be modified accordingly.    */
/* BINDTOOL_GEN_AUTOMATIC(0)                                                       */
/* BINDTOOL_USE_PYGCCXML(0)                                                        */
/* BINDTOOL_HEADER_FILE(cw_decoder.h)                                        */
/* BINDTOOL_HEADER_FILE_HASH(c26fa17d6c65895c902c02f576ebf1aa)                     */
/***********************************************************************************/

#include <pybind11/complex.h>
#include <pybind11/pybind11.h>
#include <pybind11/stl.h>

namespace py = pybind11;

#include <gnuradio/satnogs/cw_decoder.h>
// pydoc.h is automatically generated in the build directory
#include <cw_decoder_pydoc.h>

void bind_cw_decoder(py::module& m)
{

    using cw_decoder = ::gr::satnogs::cw_decoder;


    py::class_<cw_decoder, gr::satnogs::decoder, std::shared_ptr<cw_decoder>>(
        m, "cw_decoder", D(cw_decoder))

        .def(py::init(&cw_decoder::make),
             py::arg("samp_rate"),
             py::arg("fft_len"),
             py::arg("overlapping"),
             py::arg("wpm") = 22.,
             py::arg("snr") = 10.,
             py::arg("confidence") = 0.90000000000000002,
             py::arg("channels") = 16,
             py::arg("min_frame_size") = 5,
             py::arg("max_frame_size") = 256,
             D(cw_decoder, make))


        .def("decode",
             &cw_decoder::decode,
             py::arg("in"),
             py::arg("len"),
             D(cw_decoder, decode))


        .def("reset", &cw_decoder::reset, D(cw_decoder, reset))


        .def("input_multiple", &cw_decoder::input_multiple, D(cw_decoder, input_multiple))

        ;
}
