/*
 * Copyright 2023 Free Software Foundation, Inc.
 *
 * This file is part of GNU Radio
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 */

/***********************************************************************************/
/* This file is automatically generated using bindtool and can be manually edited  */
/* The following lines can be configured to regenerate this file during cmake      */
/* If manual edits are made, the following tags should be modified accordingly.    */
/* BINDTOOL_GEN_AUTOMATIC(0)                                                       */
/* BINDTOOL_USE_PYGCCXML(0)                                                        */
/* BINDTOOL_HEADER_FILE(doppler_correction_cc.h)                                        */
/* BINDTOOL_HEADER_FILE_HASH(f2874120017a4f7d6d8abcbc0ac39b8b)                     */
/***********************************************************************************/

#include <pybind11/complex.h>
#include <pybind11/pybind11.h>
#include <pybind11/stl.h>

namespace py = pybind11;

#include <gnuradio/satnogs/doppler_correction_cc.h>
// pydoc.h is automatically generated in the build directory
#include <doppler_correction_cc_pydoc.h>

void bind_doppler_correction_cc(py::module& m)
{

    using doppler_correction_cc = ::gr::satnogs::doppler_correction_cc;


    py::class_<doppler_correction_cc,
               gr::sync_block,
               gr::block,
               gr::basic_block,
               std::shared_ptr<doppler_correction_cc>>(
        m, "doppler_correction_cc", D(doppler_correction_cc))

        .def(py::init(&doppler_correction_cc::make),
             py::arg("doppler"),
             py::arg("sampling_rate"),
             py::arg("offset") = 0.,
             py::arg("corrections_per_sec") = 1000,
             py::arg("doppler_tag_name") = "doppler",
             D(doppler_correction_cc, make))


        ;
}
