/*
 * Copyright 2023 Free Software Foundation, Inc.
 *
 * This file is part of GNU Radio
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 */

/***********************************************************************************/
/* This file is automatically generated using bindtool and can be manually edited  */
/* The following lines can be configured to regenerate this file during cmake      */
/* If manual edits are made, the following tags should be modified accordingly.    */
/* BINDTOOL_GEN_AUTOMATIC(0)                                                       */
/* BINDTOOL_USE_PYGCCXML(0)                                                        */
/* BINDTOOL_HEADER_FILE(ieee802_15_4_encoder.h)                                    */
/* BINDTOOL_HEADER_FILE_HASH(0)                                                    */
/***********************************************************************************/

#include <pybind11/complex.h>
#include <pybind11/pybind11.h>
#include <pybind11/stl.h>

namespace py = pybind11;

#include <gnuradio/satnogs/encoder.h>
#include <gnuradio/satnogs/ieee802_15_4_encoder.h>
// pydoc.h is automatically generated in the build directory
#include <ieee802_15_4_encoder_pydoc.h>

void bind_ieee802_15_4_encoder(py::module& m)
{

    using ieee802_15_4_encoder = ::gr::satnogs::ieee802_15_4_encoder;
    using encoder = ::gr::satnogs::encoder;

    py::class_<ieee802_15_4_encoder,
               gr::satnogs::encoder,
               std::shared_ptr<ieee802_15_4_encoder>>(
        m, "ieee802_15_4_encoder", D(ieee802_15_4_encoder))

        .def(py::init(&ieee802_15_4_encoder::make),
             py::arg("preamble"),
             py::arg("preamble_len"),
             py::arg("sync_word"),
             py::arg("crc"),
             py::arg("scrambler"),
             py::arg("var_len") = true,
             py::arg("rs") = false,
             D(ieee802_15_4_encoder, make))


        .def("encode",
             &ieee802_15_4_encoder::encode,
             py::arg("msg"),
             D(ieee802_15_4_encoder, encode))

        ;
}
