/*
 * Copyright 2023 Free Software Foundation, Inc.
 *
 * This file is part of GNU Radio
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 */

/***********************************************************************************/
/* This file is automatically generated using bindtool and can be manually edited  */
/* The following lines can be configured to regenerate this file during cmake      */
/* If manual edits are made, the following tags should be modified accordingly.    */
/* BINDTOOL_GEN_AUTOMATIC(0)                                                       */
/* BINDTOOL_USE_PYGCCXML(0)                                                        */
/* BINDTOOL_HEADER_FILE(sigmf_metadata.h)                                        */
/* BINDTOOL_HEADER_FILE_HASH(5f413228e372855882bbba918ae96083)                     */
/***********************************************************************************/

#include <pybind11/complex.h>
#include <pybind11/pybind11.h>
#include <pybind11/stl.h>

namespace py = pybind11;

#include <gnuradio/satnogs/metadata.h>
#include <gnuradio/satnogs/sigmf_metadata.h>
// pydoc.h is automatically generated in the build directory
#include <sigmf_metadata_pydoc.h>

void bind_sigmf_metadata(py::module& m)
{

    using sigmf_metadata = ::gr::satnogs::sigmf_metadata;

    py::class_<gr::satnogs::metadata, std::shared_ptr<gr::satnogs::metadata>>(m,
                                                                              "metadata");

    py::class_<sigmf_metadata, gr::satnogs::metadata, std::shared_ptr<sigmf_metadata>>(
        m, "sigmf_metadata", D(sigmf_metadata))

        .def("transform",
             &sigmf_metadata::transform,
             py::arg("m"),
             D(sigmf_metadata, transform))


        .def("to_file",
             &sigmf_metadata::to_file,
             py::arg("filename"),
             D(sigmf_metadata, to_file))


        .def("to_sting", &sigmf_metadata::to_sting, D(sigmf_metadata, to_sting))

        ;
}
