/*
 * Copyright 2023 Free Software Foundation, Inc.
 *
 * This file is part of GNU Radio
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 */

/***********************************************************************************/
/* This file is automatically generated using bindtool and can be manually edited  */
/* The following lines can be configured to regenerate this file during cmake      */
/* If manual edits are made, the following tags should be modified accordingly.    */
/* BINDTOOL_GEN_AUTOMATIC(0)                                                       */
/* BINDTOOL_USE_PYGCCXML(0)                                                        */
/* BINDTOOL_HEADER_FILE(whitening.h)                                               */
/* BINDTOOL_HEADER_FILE_HASH(0)                                                    */
/***********************************************************************************/

#include <pybind11/complex.h>
#include <pybind11/pybind11.h>
#include <pybind11/stl.h>

namespace py = pybind11;

#include <gnuradio/satnogs/whitening.h>
// pydoc.h is automatically generated in the build directory
#include <whitening_pydoc.h>

void bind_whitening(py::module& m)
{

    using whitening = ::gr::satnogs::whitening;


    py::class_<whitening, std::shared_ptr<whitening>>(m, "whitening", D(whitening))
        .def(py::init(&whitening::make),
             py::arg("mask"),
             py::arg("seed"),
             py::arg("order"),
             py::arg("msb") = false,
             py::arg("self_sync") = false,
             D(whitening, make))
        .def("unique_id", &whitening::unique_id, D(whitening, unique_id))
        .def_static("make_ccsds",
                    &whitening::make_ccsds,
                    py::arg("msb") = false,
                    D(whitening, make_ccsds))
        .def_static("make_g3ruh",
                    &whitening::make_g3ruh,
                    py::arg("msb") = false,
                    D(whitening, make_g3ruh))
        .def_static("make_none", &whitening::make_none, D(whitening, make_none))
        .def("reset", &whitening::reset, D(whitening, reset))
        .def("scramble",
             &whitening::scramble,
             py::arg("out"),
             py::arg("in"),
             py::arg("len"),
             D(whitening, scramble))
        .def("descramble",
             &whitening::descramble,
             py::arg("out"),
             py::arg("in"),
             py::arg("len"),
             D(whitening, descramble))
        .def("scramble_one_bit_per_byte",
             &whitening::scramble_one_bit_per_byte,
             py::arg("out"),
             py::arg("in"),
             py::arg("bits_num"),
             D(whitening, scramble_one_bit_per_byte))
        .def("descramble_one_bit_per_byte",
             &whitening::descramble_one_bit_per_byte,
             py::arg("out"),
             py::arg("in"),
             py::arg("bits_num"),
             D(whitening, descramble_one_bit_per_byte));
}
